// A Simple Browser: Use a JEditorPane to display the contents of a
// file on a Web server.
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;

public class SimpleBrowserGUI extends JFrame {
   private JTextField pathname;
   private JEditorPane displayPane;

   // set up the GUI
   public SimpleBrowserGUI() {
      super( "Web Browser Light" );

      // create pathname field and register its listener
      pathname = new JTextField( "Enter URL here" );
      pathname.addActionListener(
         new ActionListener() {
            public void actionPerformed( ActionEvent event ) {
               // get document specified by user
               loadDocument( event.getActionCommand() );
            }
         }
      );

      // create displayPane and register HyperlinkEvent listener
      // with the display pane.
      displayPane = new JEditorPane();
      displayPane.setEditable( false );  // If links are to work.
      displayPane.addHyperlinkListener(
         new HyperlinkListener() {
            // if user clicked hyperlink, go to specified page
            public void hyperlinkUpdate( HyperlinkEvent event ) {
               if ( event.getEventType() ==
                    HyperlinkEvent.EventType.ACTIVATED )
                  loadDocument( event.getURL().toString() );
            }
         }
      );

      // create the layout
      Container container = getContentPane();
      container.add( pathname, BorderLayout.NORTH );
      container.add( new JScrollPane( displayPane ),
                     BorderLayout.CENTER );

      // set size and put up the GUI
      setSize( 400, 300 );
      setVisible( true );
   }

   private void loadDocument( String location ) {
      // load document and display location
      try {
         System.out.println( location );
         displayPane.setPage( location );
         pathname.setText( location );
      } catch ( IOException ioException ) {
         JOptionPane.showMessageDialog( this,
            "Error retrieving specified URL", "Bad URL",
            JOptionPane.ERROR_MESSAGE );
      }
   }

   public static void main( String[] args ) {
      SimpleBrowserGUI browser = new SimpleBrowserGUI();
      browser.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
   }
}