import java.net.*;

public class URLParser {

  public static void main(String[] args) {
    try {
      if (args.length > 1) {
        URL url = new URL( args[0] );
        printURLInfo( url );
        return;
      }

      URL url1 = new URL( "http://java.sun.com" +
                           "/j2se/1.4.2/docs/api/index.html" );
      printURLInfo( url1 );
      URL url2 = new URL( "http://www.javaworld.com" +
                           "/javaforums/ubbthreads.php?Cat=&C=2" );
      printURLInfo( url2 );
      URL url3 = new URL( "http://www.bond.edu.au" +
                          "/it/subjects/subs-pg.htm#inft718");
      printURLInfo( url3 );

      URL url4 = new URL( "ftp", "www.javaworld.com",
                           "javaforums/ubbthreads.txt" );
      printURLInfo( url4 );

      URL url5 = new URL( "http://www.ii.uib.no");
      printURLInfo( url5 );
      URL url6 = new URL( url5, "undervisning");
      printURLInfo( url6 );

      URL url9 = new URL( "http", "java.sun.com", 80,
                           "/j2se/1.4.2/docs/api/index.html" );
      printURLInfo( url9 );

      URL url10 = new URL( null, "http://java.sun.com" +
                           "/j2se/1.4.2/docs/api/index.html" );
      printURLInfo( url10 );

//    URL url7 = new URL( "mailto:khalid@ii.uib.no");
      URL url7 = new URL( "mailto:sdada");
      printURLInfo( url7 );

      URL url8 = new URL( "vvvv://www.ii.uib.no");
      printURLInfo( url8 );

    } catch (MalformedURLException mue) {
      System.err.println("Missing protocol or unknown protocol!");
    }
  }

  public static void printURLInfo(URL url) {
      // Print the components of the URL.
      System.out.println("-----------");
      System.out.println("URL :      " + url );
      System.out.println("Protocol : " + url.getProtocol() );
      System.out.println("Hostname : " + url.getHost() );
      System.out.println("Port     : " + url.getPort() );
      System.out.println("Path     : " + url.getPath() );
      System.out.println("Filename : " + url.getFile() );
      System.out.println("Reference: " + url.getRef() );
      System.out.println("Query:     " + url.getQuery() );
  }
}